aedist(1)

NAME
aedist - remotely distribute a change

SYNOPSIS
aedist -Send [ option... ]
aedist -Receive [ option... ]
aedist -REPlay [ option... ] -f URL
aedist -MIssing [ option... ] -f URL
aedist -PENding [ option... ] -f URL
aedist -Inventory [ option... ]
aedist -ARChive [ option... ]
aedist -List [ option... ]
aedist -Help
aedist -VERSion

DESCRIPTION
The aedist command is used to send and receive change sets to facilitate geographically distributed development. The expected transport mechanism is e-mail, however other mechanisms are equally possible.

The basic function is to reproduce a change, so a command like
    aedist -send | aedist -receive
may be used to clone a change, though less efficiently than aeclone(1). The file format used is designed to withstand mail servers, so activities such as
    aedist -send | e-mail | aedist -receive
(where e-mail represents sending, transporting and receiving your e-mail) will reproduce the change on a remote system. With suitable tools (such as PGP) is it possible to
    aedist -send | encrypt | e-mail | decrypt | aedist -receive
The mechanism is also designed to allow web-based distribution such as
    aedist -send | web-server → web-browser | aedist -receive
by the use of appropriate CGI scripts and mailcap entries.

It is possible to support both a “push” model and a “pull” model using this command. For suggestions and ideas for various ways to do this, see the Aegis Users Guide.

SEND
The send variant takes a specified change, or baseline, and constructs a distribution package containing all of the change attributes and source file attributes and source file contents. The result is compressed, and encoded into a text format which can be sent as e-mail without being corrupted by the mail transfer agents along the way.

  Options
The following options are understood by the send variant:

-BaseLine
    This option may be used to specify the source of a project, rather than a change. Implies the -Entire_Source option, unless over-ridden.

-Change number
    This option may be used to specify a particular change within a project. See aegis(1) for a complete description of this option.

-COMPATibility version-number
    This option may be used to specify the version of aedist(1) which will be receiving this change set. This information is used to select which features to include in the data, and which to omit. By default, the latest feature set will be used.

-compression-algorithm name
    This option may be used to specify the compression to be used. They are listed on order of compression effeciency.

    none
        Use no compression (not always meaningful for all commands).

    gzip
        Use the compression used by the gzip(1) program.

    bzip2
        Use the compression used by the bzip2(1) program.

    More compression algorithms may be added in the future.

-COMPress
    This option is deprecated in favour of the -comp-alg=gzip or -comp-alg=bzip2 options.

-No_COMPress
    This options is deprecated in favour of the -comp-alg=none option.

-Content_Transfer_Encoding name
    This option may be used to specify the content transfer encoding to be used. It may take one of the following values:

    None
        No content transfer encoding is to be performed.

    Base64
        The MIME base 64 encoding is to be used. This is the default.

    Quoted_Printable
        The MIME quoted printable encoding is to be used.

    Unix_to_Unix_encode
        The ancient unix-to-unix encoding is to be used.

    These encodings may be abbreviated in the same way as comment line options.

-Ascii_Armor
    This means the same as the “-cte=base64” option above.

-No_Ascii_Armor
    This means the same as the “-cte=none” option above.

-DELta number
    This option may be used to specify a particular delta in the project's history to copy the file from, rather than the most current version. If the delta has been given a name (see aedn(1) for how) you may use a delta name instead of a delta number. It is an error if the delta specified does not exist. Delta numbers start from 1 and increase; delta 0 is a special case meaning “when the branch started”.

-DELta_Date string
    This option may be used to specify a particular date and time in the project's history to copy the file from, rather than the most current version. It is an error if the string specified cannot be interpreted as a valid date and time. Quote the string if you need to use spaces.

-DELta_From_Change number
    This option may be used to specify a particular project delta from its change number.

-Description_Header
    This option may be used to add an RFC 822 style header to the change description being sent, with a From and Date line. This is the default.

-No_Description_Header
    This option suppresses the description header.

-Entire_Source
    This option may be used to send the entire source of the project, as well as the change source files.

-Ignore_UUID
    This option may be used to ignore the UUID, if present, of the outgoing change set.

-No_Ignore_UUID
    This option forces the aedist command to use the outgoing change set's UUID information. This is the default (unless the compatibility option will to avoid attributes).

-Mime_Headers
    This option may be use to force the presence of mime headers in the output, in circumstances they would usually be absent.

-No_Mime_Headers
    This option may be use to force the absence of mime headers in the output, in circumstances where they would usually be present.

-Partial_Source
    This option may be used to send only source files of a change. This is the default, except for the -BaseLine option.

-Output filename
    This option may be used to specify the output file. The output is sent to the standard output by default.

-PATch
    This option is deprecated. Please use the -COMPATibility option instead.

-No_PATch
    This option is deprecated. Please use the -COMPATibility=4.6 option instead.

-Project name
    This option may be used to select the project of interest. When no -Project option is specified, the AEGIS_PROJECT environment variable is consulted. If that does not exist, the user's $HOME/.aegisrc file is examined for a default project field (see aeuconf(5) for more information). If that does not exist, when the user is only working on changes within a single project, the project name defaults to that project. Otherwise, it is an error.

-Signed_Off_By
    This option may be used to have a Signed-off-by: line appended to the change set description.

-No_Signed_Off_By
    This option may be used to prevent a Signed-off-by: line from being appended to the change set description.

RECEIVE
The receive variant takes a change package created by the send variant and creates an Aegis change (see aenc(1)) to implement the change within. Files are added to the change (see aerm(1), aecp(1), aenf(1) and aent(1)) and then the file contents are unpackaged into the development directory.

The change is then built (see aeb(1)), differenced (see aed(1)), and tested (see aet(1)). If all of this is successful, development of the change is ended (see aed(1)). The automatic process stops at this point, so that a local reviewer can confirm that the change is desired.

  Notification
The aedist command invokes various other Aegis commands. The usual notifications that these commands would issue are issued.

  Options
The following options are understood by the receive variant:

-Change number
    This option may be used to choose the change number to be used, otherwise one will be chosen automatically.

-DELta number
    This option may be used to specify a particular delta in the project's history to copy the file from, just as for the aecp(1) command. You may also use a delta name instead of a delta number.

-DIRectory path
    This option may be used to specify which directory is to be used. It is an error if the current user does not have appropriate permissions to create the directory path given. This must be an absolute path.

    Caution: If you are using an automounter do not use `pwd` to make an absolute path, it usually gives the wrong answer.

-File filename
    Read the change set from the specified file. The default is to read it from the standard input. The filename `-' is understood to mean the standard input.

    If your system has libcurl(3), and Aegis was configured to use it at compile time (this is the default if it is available) you will also be able to specify a Uniform Resource Locator (URL) in place of the file name. The relevant data will be downloaded. (The -Verbose option will provide a progress bar.)

-PATch
    This option may be used to apply patches from the input, if available. This generally results in fewer merge problems, but it requires the two repositories to be well synchronized. This is the default.

-No_PATch
    This option may be used to ignore patches in the input, if any are present.

-Ignore_UUID
    This option may be used to ignore the UUID, if present, of the incoming change set.

-No_Ignore_UUID
    This option force the aedist command to use the change set's UUID. This is the default.

-Project name
    This option may be used to set the project name. If not specified, the project name in the input package will be used, rather than the usual project name defaulting mechanism.

-Trojan
    This option may be used to treat the change set as if it had a Trojan horse attack in it.

-No_Trojan
    This option may be used to treat the change set as if it definitely does not have a Trojan horse attack in it. Use with extreme care. You need to have authenticated the message with something like PGP first and know the the author well.

  Security
Receiving changes by e-mail, and automatically committing them to the baseline without checking them, would be a recipe for disaster. A number of safeguards are provided:

•   The format of the package is confirmed to be correct, and the package verified for internal consistency, before it is unpacked and acted upon.

•   The automatic portion of the process stops when development ends. This ensures that a local reviewer validates the change before it is committed, preventing accidental or malicious damage.

•   If the change seeks to update the project config file, the automatic process terminates before the build or difference occurs. This is because this file could contain trojans for these operations, so a human must examine the file before the change proceeds any further.

•   There is a potential_trojan_horse = [ string ]; field in the projectconfig file. Nominate build configuration files, shell scripts, code generators, etc here to specify files in addition to the project configuration file which should cause the automatic processing to halt.

•   The use of e-mail authentication and encryption systems, such as PGP and GPG, are encouraged. However, it is expected that this processing will occur after aedist --send has constructed the package and before aedist --receive examines and acts on the package. Verification of the sender is the surest defense against trojan horses.

•   Automatic sending and receiving of packages is supported, but not implemented within the aedist command. It is expected that the aedist command will be used within shell scripts customized for your site and its unique security requirements. See the Aegis User Guide for several different ways to do this.

•   The more you use Aegis' test management facilities (see aent(1) and aet(1)) the harder it is for an inadequate change to get into the baseline.

  Duplicate Storms
In a distributed development environment, it is common for change sets to eventually be propagated back to the originator. There are situations (particularly in some star topologies) where several copies of the package will return to the originator.

If these change sets are not detected at the review stage, and are propagated out yet again, there is the possibility of an exponential explosion of redundant packages being distributed again and again.

To combat this, changes are checked after the files are unpacked, but before and build or difference or test is performed. The “aecpu --unchanged” command is used to exclude all files that the local repository already has in the desired form. If no change files remain after this, the change is dropped entirely (see aedbu(1) and aencu(1)).

REPLAY
If you are tracking a remote site which makes a project available via the aeget(1) web interface, you can automatically synchronize with the remote site using the aedist -replay command.

For example, Aegis developers can track the master project with a command of the form:
    aedist -p aegis.4.24.2 --replay -f aegis.sourceforge.net
This command is internally rewritten as
    aedist --replay -p aegis.4.24.2 -f \
      http://aegis.sf.net/cgi-bin/aeget/aegis.4.24.2/?inventory
If your cgi-bin directory is somewhere else, you will need to use the long form.

The change set inventory page is human readable if you want to see what it contains. The links on this page provide all the information necessary to download any of the change sets listed.

This command reads the list of change set UUIDs from the remote repository, and compares it with the list of change set UUIDs in the local repository, and fetches any that are not present locally.

Each of the change sets required are downloaded and unpacked by issuing a command such as
    aedist -rec -f \
      http://aegis.sf.net/cgi-bin/aeget/aegis.4.19.C010/?aedist
If this completes successfully (and it is possible it won't, either because of trojan warnings, or some conflict between local changes and the incoming remote changes), and your project has its develop_end_action set to goto_awaiting_integration, the change will be integrated using a command such as:
    aeintegratq -p aegis.4.24.2 -c 10
and then starts over again for the next missing change set.

This command will attempt to use the same change number as in the remote repository, if it is available.

  Options
The following options are understood by this variant:

-EXclude_UUID UUID
    This option may be used to exclude some change sets from being downloaded and unpacked. This option may be used more than once.

-No_EXclude_UUID UUID
    This option may be used to explicitly list change sets to be downloaded and unpacked, to the exclusion of all others. This option may be used more than once.

-EXclude_VERsion pattern
    This option may be used to explicitly exclude some change set from being downloaded and unpacked. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-INclude_VERsion pattern
    This option may be used to explicitly list change sets to be downloaded and unpacked, to the exclusion of all others. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-File filename
    Read the change set from the specified file. The default is to read it from the standard input. The filename `-' is understood to mean the standard input.

    If your system has libcurl(3), and Aegis was configured to use it at compile time (this is the default if it is available) you will also be able to specify a Uniform Resource Locator (URL) in place of the file name. The relevant data will be downloaded. (The -Verbose option will provide a progress bar.)

-MAXimum
    This option may be used to download as many changes as possible by excluding the maximum number of local changes sets, by excluding both local change sets UUIDs (the default) but also excluding UUIDs mentioned in change "original-uuid" attributes.

-PErsevere
    This option may be used to specify that all relevant change sets should be downloaded, even if some fail. Defaults to the user's persevere_preference if not specified, see aeuconf(5) for more information.

-No_PErsevere
    This option may be used to specify that the downloading of change sets should stop after the first failure. Defaults to the user's persevere_preference if not specified, see aeuconf(5) for more information.

-Project name
    This option may be used to select the project of interest. When no -Project option is specified, the AEGIS_PROJECT environment variable is consulted. If that does not exist, the user's $HOME/.aegisrc file is examined for a default project field (see aeuconf(5) for more information). If that does not exist, when the user is only working on changes within a single project, the project name defaults to that project. Otherwise, it is an error.

-Trojan
    This option is passed to any aedist(1) commands spawned by this command.

-No_Trojan
    This option is passed to any aedist(1) commands spawned by this command.

-Not_Compatibility
    This option must be used when using aedist --replay against a file based inventory.

MISSING
If you want to see the change sets that aedist -replay may download before it goes ahead and does it, you can use a command such as:
    aedist --missing -f aegis.sf.net
In particular, this allows you to select appropriate UUIDs for the aedist -replay -exclude or -no-exclude options.

  Options
The following options are understood by this variant:

-EXclude_UUID UUID
    This option may be used to exclude some change sets from being listed. This option may be used more than once.

-No_EXclude_UUID UUID
    This option may be used to explicitly list change sets to be listed, to the exclusion of all others. This option may be used more than once.

-EXclude_VERsion pattern
    This option may be used to explicitly exclude some change set from being listed. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-INclude_Version pattern
    This option may be used to explicitly list change sets to be listed, to the exclusion of all others. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-MAXimum
    This option may be used to download as many changes as possible by excluding the maximum number of local changes sets, by excluding both local change sets UUIDs (the default) but also excluding UUIDs mentioned in change "original-uuid" attributes.

PENDING
If you want to see the change sets that a remote repository is missing with respect to yours, you can use a command such as:
    aedist --pending -f aegis.sf.net

  Options
The following options are understood by this variant: -EXclude_UUID UUID This option may be used to exclude some local change sets from being listed. This option may be used more than once.

-No_EXclude_UUID UUID
    This option may be used to explicitly list local change sets to be listed, to the exclusion of all others. This option may be used more than once.

-EXclude_VERsion pattern
    This option may be used to explicitly exclude some local change set from being listed. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-INclude_VERsion pattern
    This option may be used to explicitly list local change sets to be listed, to the exclusion of all others. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

INVENTORY
The inventory variant can be used as an alternative to aeget to generate the inventory used by the replay, missing and pending variants. The idea is to run the inventory variant on the development machine and then upload its output to the public repository. In order to generate the inventory you can use a command such as:
    aedist --inventory -proj project > inventory.html

  Options
The following options are understood by this variant:

-AEGET
    This option is used by aeget to require the original aeget(1) behavior.

-All
    This option is used to require the inclusion of the UUIDs contained in the original-UUID attribute of each change.

-EXclude_Version pattern
    This option may be used to explicitly exclude some change set to be added to the inventory file. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-INclude_Version pattern
    This option may be used to explicitly list change sets to be added to the the inventory file, to the exclusion of all others. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-path_prefix_add
    This option is used to add a path prefix to the URLs generated in the inventory.

-Project name
    This option may be used to select the project of interest. When no -Project option is specified, the AEGIS_PROJECT environment variable is consulted. If that does not exist, the user's $HOME/.aegisrc file is examined for a default project field (see aeuconf(5) for more information). If that does not exist, when the user is only working on changes within a single project, the project name defaults to that project. Otherwise, it is an error.

ARCHIVE
As an alternative to using the aeget(1) CGI program, the aedist archive variant is provided. This variant can be used to populate a directory with the aedist archives of each change with an UUID. The archives will have a name based on the UUID of the change with extension ".ae", the fingerprint of the archive will be stored in a file with the same (base)name with extension ".fp". Running the archive variant multiple times against the same target directory will update that directory, adding the files of changes integrated after the last run and regenerating the files if a corruption is detected.

  Options
The following options are understood by the archive variant:

-Change-Directory directory
    This option is used to designate the directory to be populated with the aedist(1) generated files. If this option is not used then the current directory is used as the target of the command. The directory must exists and be accessible by the user running the command.

-EXclude_Version pattern
    This option may be used to explicitly exclude some change set to be added to the target directory. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-INclude_Version pattern
    This option may be used to explicitly list change sets to be added to the target directory, to the exclusion of all others. The pattern is matched against the version as displayed in the inventory. This option may be used more than once.

-Project name
    This option may be used to select the project of interest. When no -Project option is specified, the AEGIS_PROJECT environment variable is consulted. If that does not exist, the user's $HOME/.aegisrc file is examined for a default project field (see aeuconf(5) for more information). If that does not exist, when the user is only working on changes within a single project, the project name defaults to that project. Otherwise, it is an error.

LIST
The list variant can be used to list the contents of a package without actually unpacking it first. The output is reminiscent of the aegis -list change-details output.

  Options
The following options are understood by the list variant:

-File filename
    Read the change set from the specified file. The default is to read it from the standard input. The filename `-' is understood to mean the standard input.

    If your system has libcurl(3), and Aegis was configured to use it at compile time (this is the default if it is available) you will also be able to specify a Uniform Resource Locator (URL) in place of the file name. The relevant data will be downloaded. (The -Verbose option will provide a progress bar.)

-Output filename
    This option may be used to specify the output file. The output is sent to the standard output by default. Only useful with the -List option.

OPTIONS
The following options to this command haven't been mentioned yet:

-Help
    This option may be used to obtain more information about how to use the aedist program.

All options may be abbreviated; the abbreviation is documented as the upper case letters, all lower case letters and underscores (_) are optional. You must use consecutive sequences of optional letters.

All options are case insensitive, you may type them in upper case or lower case or a combination of both, case is not important.

For example: the arguments "-project, "-PROJ" and "-p" are all interpreted to mean the -Project option. The argument "-prj" will not be understood, because consecutive optional characters were not supplied.

Options and other command line arguments may be mixed arbitrarily on the command line, after the function selectors.

The GNU long option names are understood. Since all option names for aedist are long, this means ignoring the extra leading '-'. The "--option=value" convention is also understood.

FILE FORMAT
The file format re-uses existing formats, rather than introduce anything new. This means it is possible to extract the contents of a package even when aedist is unavailable.

•   The source files and other information is stored as a cpio(1) archive.

•   The archive is compressed using the bzip2(1) format. Typically primary source files are ASCII text, resulting in significant compression.

•   The compressed result is encoded using the MIME base64 encoding. This makes the result approximately 33% larger than the compressed binary would be, but still smaller than the primary sources.

The cpio archive is used to store

etc/project-name
    This contains the project name to apply the package to, unless over-ridden by the --project command line option.

etc/change-number
    This contains the change number of the original change, this may be preserved if available on the target repository unless over-ridden by the --change command line option.

etc/change-set
    This contains the change attributes and the list of source files and usages, in aecstate(5) format.

patch/filename
    Each modified or renamed file in the package (named in etc/change-set) appears under the patch directory. The file may be empty unless some edits was done on the source repository.

src/filename
    Each source file in the package (named in etc/change-set) appears under the src/ directory.

Extra files, or files out of order, are a fatal error.

EXIT STATUS
The aedist command will exit with a status of 1 on any error. The aedist command will only exit with a status of 0 if there are no errors.

ENVIRONMENT VARIABLES
See aegis(1) for a list of environment variables which may affect this command. See aepconf(5) for the project configuration file's project_specific field for how to set environment variables for all commands executed by Aegis.

COPYRIGHT
aedist version 4.24.2.D001
Copyright (C) 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 20 Peter Miller

The aedist program comes with ABSOLUTELY NO WARRANTY; for details use the 'aedist -VERSion License' command. This is free software and you are welcome to redistribute it under certain conditions; for details use the 'aedist -VERSion License' command.

AUTHOR
Peter Miller | E-Mail: | millerp@canb.auug.org.au
/\/\* | WWW: | http://www.canb.auug.org.au/~millerp/

CREDITS
This program evolved through discussion with a number of people. If I have forgotten anyone, it wasn't intentional.
Ralf Fassel | <ralf@akutech.de> | Catching trojan horses.
Walter Franzini | <walter.franzini@sys-net.it> | coding -replay download
Florian Xhumari | <Florian.Xhumari@inria.fr> | On the need for pull interfaces.
Graham Wheeler | <gram@cdsec.com> | HTTP pull interfacing.